diff -uwrN sourceold/SuddenDeath/SuddenDeath.vcxproj source/SuddenDeath/SuddenDeath.vcxproj
--- sourceold/SuddenDeath/SuddenDeath.vcxproj	2016-10-31 07:17:11.096013500 +1000
+++ source/SuddenDeath/SuddenDeath.vcxproj	2017-01-18 19:57:04.564844800 +1000
@@ -18,14 +18,12 @@
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.Default.props" />
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
-    <UseOfMfc>false</UseOfMfc>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
     <PlatformToolset>v110_xp</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
-    <UseOfMfc>false</UseOfMfc>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
     <PlatformToolset>v110_xp</PlatformToolset>
@@ -89,7 +87,7 @@
       <DebugInformationFormat>ProgramDatabase</DebugInformationFormat>
       <MultiProcessorCompilation>true</MultiProcessorCompilation>
       <MinimalRebuild>false</MinimalRebuild>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
     </ClCompile>
     <ResourceCompile>
       <PreprocessorDefinitions>NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
@@ -102,7 +100,6 @@
       <GenerateDebugInformation>true</GenerateDebugInformation>
       <GenerateMapFile>true</GenerateMapFile>
       <MapFileName>$(TargetDir)$(TargetName).map</MapFileName>
-      <MapExports>false</MapExports>
       <SubSystem>Windows</SubSystem>
       <OptimizeReferences>true</OptimizeReferences>
       <EnableCOMDATFolding>true</EnableCOMDATFolding>
@@ -149,7 +146,6 @@
     <ClCompile>
       <Optimization>Disabled</Optimization>
       <IntrinsicFunctions>true</IntrinsicFunctions>
-      <FavorSizeOrSpeed>Speed</FavorSizeOrSpeed>
       <AdditionalIncludeDirectories>.;..\MemoryManager;..\scripts;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
       <PreprocessorDefinitions>D3D_DEBUG_INFO;DEBUG;MEMORY_MANAGER;SUDDENDEATH_EXPORTS;WIN32;_CRT_SECURE_NO_DEPRECATE;_HAS_EXCEPTIONS=0;_WINDOWS;SSGMPLUGIN;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <StringPooling>true</StringPooling>
@@ -159,7 +155,7 @@
       <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
       <FloatingPointModel>Precise</FloatingPointModel>
       <RuntimeTypeInfo>true</RuntimeTypeInfo>
       <PrecompiledHeader>Use</PrecompiledHeader>
diff -uwrN sourceold/bansystem/bansystem.vcxproj source/bansystem/bansystem.vcxproj
--- sourceold/bansystem/bansystem.vcxproj	2016-10-31 07:17:11.162013500 +1000
+++ source/bansystem/bansystem.vcxproj	2017-01-18 19:57:04.564844800 +1000
@@ -18,14 +18,12 @@
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.Default.props" />
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
-    <UseOfMfc>false</UseOfMfc>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
     <PlatformToolset>v110_xp</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
-    <UseOfMfc>false</UseOfMfc>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
     <PlatformToolset>v110_xp</PlatformToolset>
@@ -89,7 +87,7 @@
       <DebugInformationFormat>ProgramDatabase</DebugInformationFormat>
       <MultiProcessorCompilation>true</MultiProcessorCompilation>
       <MinimalRebuild>false</MinimalRebuild>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
     </ClCompile>
     <ResourceCompile>
       <PreprocessorDefinitions>NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
@@ -102,7 +100,6 @@
       <GenerateDebugInformation>true</GenerateDebugInformation>
       <GenerateMapFile>true</GenerateMapFile>
       <MapFileName>$(TargetDir)$(TargetName).map</MapFileName>
-      <MapExports>false</MapExports>
       <SubSystem>Windows</SubSystem>
       <OptimizeReferences>true</OptimizeReferences>
       <EnableCOMDATFolding>true</EnableCOMDATFolding>
@@ -149,7 +146,6 @@
     <ClCompile>
       <Optimization>Disabled</Optimization>
       <IntrinsicFunctions>true</IntrinsicFunctions>
-      <FavorSizeOrSpeed>Speed</FavorSizeOrSpeed>
       <AdditionalIncludeDirectories>.;..\MemoryManager;..\scripts;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
       <PreprocessorDefinitions>D3D_DEBUG_INFO;DEBUG;MEMORY_MANAGER;BANSYSTEM_EXPORTS;WIN32;_CRT_SECURE_NO_DEPRECATE;_HAS_EXCEPTIONS=0;_WINDOWS;SSGMPLUGIN;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <StringPooling>true</StringPooling>
@@ -159,7 +155,7 @@
       <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
       <FloatingPointModel>Precise</FloatingPointModel>
       <RuntimeTypeInfo>true</RuntimeTypeInfo>
       <PrecompiledHeader>Use</PrecompiledHeader>
diff -uwrN sourceold/crates/crates.vcxproj source/crates/crates.vcxproj
--- sourceold/crates/crates.vcxproj	2016-10-31 07:17:11.182013500 +1000
+++ source/crates/crates.vcxproj	2017-01-18 19:57:04.668244800 +1000
@@ -18,14 +18,12 @@
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.Default.props" />
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
-    <UseOfMfc>false</UseOfMfc>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
     <PlatformToolset>v110_xp</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
-    <UseOfMfc>false</UseOfMfc>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
     <PlatformToolset>v110_xp</PlatformToolset>
@@ -89,7 +87,7 @@
       <DebugInformationFormat>ProgramDatabase</DebugInformationFormat>
       <MultiProcessorCompilation>true</MultiProcessorCompilation>
       <MinimalRebuild>false</MinimalRebuild>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
     </ClCompile>
     <ResourceCompile>
       <PreprocessorDefinitions>NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
@@ -102,7 +100,6 @@
       <GenerateDebugInformation>true</GenerateDebugInformation>
       <GenerateMapFile>true</GenerateMapFile>
       <MapFileName>$(TargetDir)$(TargetName).map</MapFileName>
-      <MapExports>false</MapExports>
       <SubSystem>Windows</SubSystem>
       <OptimizeReferences>true</OptimizeReferences>
       <EnableCOMDATFolding>true</EnableCOMDATFolding>
@@ -149,7 +146,6 @@
     <ClCompile>
       <Optimization>Disabled</Optimization>
       <IntrinsicFunctions>true</IntrinsicFunctions>
-      <FavorSizeOrSpeed>Speed</FavorSizeOrSpeed>
       <AdditionalIncludeDirectories>.;..\MemoryManager;..\scripts;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
       <PreprocessorDefinitions>D3D_DEBUG_INFO;DEBUG;MEMORY_MANAGER;CRATES_EXPORTS;WIN32;_CRT_SECURE_NO_DEPRECATE;_HAS_EXCEPTIONS=0;_WINDOWS;SSGMPLUGIN;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <StringPooling>true</StringPooling>
@@ -159,7 +155,7 @@
       <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
       <FloatingPointModel>Precise</FloatingPointModel>
       <RuntimeTypeInfo>true</RuntimeTypeInfo>
       <PrecompiledHeader>Use</PrecompiledHeader>
diff -uwrN sourceold/example-plugin/example-plugin.vcxproj source/example-plugin/example-plugin.vcxproj
--- sourceold/example-plugin/example-plugin.vcxproj	2016-10-31 07:17:12.270013500 +1000
+++ source/example-plugin/example-plugin.vcxproj	2017-01-18 19:57:04.629244800 +1000
@@ -18,14 +18,12 @@
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.Default.props" />
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
-    <UseOfMfc>false</UseOfMfc>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
     <PlatformToolset>v110_xp</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
-    <UseOfMfc>false</UseOfMfc>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
     <PlatformToolset>v110_xp</PlatformToolset>
@@ -60,7 +58,6 @@
     <ClCompile>
       <Optimization>Disabled</Optimization>
       <IntrinsicFunctions>true</IntrinsicFunctions>
-      <FavorSizeOrSpeed>Speed</FavorSizeOrSpeed>
       <AdditionalIncludeDirectories>.;..\MemoryManager;..\scripts;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
       <PreprocessorDefinitions>SSGMPLUGIN;_CRT_SECURE_NO_DEPRECATE;WIN32;_DEBUG;_WINDOWS;_USRDLL;EXAMPLEPLUGIN_EXPORTS;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <StringPooling>true</StringPooling>
@@ -70,7 +67,7 @@
       <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
       <FloatingPointModel>Precise</FloatingPointModel>
       <RuntimeTypeInfo>true</RuntimeTypeInfo>
       <PrecompiledHeader>Use</PrecompiledHeader>
@@ -145,7 +142,7 @@
       <DebugInformationFormat>ProgramDatabase</DebugInformationFormat>
       <MultiProcessorCompilation>true</MultiProcessorCompilation>
       <MinimalRebuild>false</MinimalRebuild>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
     </ClCompile>
     <Link>
       <AdditionalDependencies>%(AdditionalDependencies)</AdditionalDependencies>
@@ -154,7 +151,6 @@
       <GenerateDebugInformation>true</GenerateDebugInformation>
       <GenerateMapFile>true</GenerateMapFile>
       <MapFileName>$(TargetDir)$(TargetName).map</MapFileName>
-      <MapExports>false</MapExports>
       <SubSystem>Windows</SubSystem>
       <OptimizeReferences>true</OptimizeReferences>
       <EnableCOMDATFolding>true</EnableCOMDATFolding>
diff -uwrN sourceold/randomstartingcredits/RandomStartingCredits.vcxproj source/randomstartingcredits/RandomStartingCredits.vcxproj
--- sourceold/randomstartingcredits/RandomStartingCredits.vcxproj	2016-10-31 07:17:12.294013500 +1000
+++ source/randomstartingcredits/RandomStartingCredits.vcxproj	2017-01-18 19:57:04.611644800 +1000
@@ -18,7 +18,6 @@
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.Default.props" />
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
-    <UseOfMfc>false</UseOfMfc>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
     <PlatformToolset>v110_xp</PlatformToolset>
@@ -89,7 +88,7 @@
       <DebugInformationFormat>ProgramDatabase</DebugInformationFormat>
       <MultiProcessorCompilation>true</MultiProcessorCompilation>
       <MinimalRebuild>false</MinimalRebuild>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
     </ClCompile>
     <ResourceCompile>
       <PreprocessorDefinitions>NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
@@ -102,7 +101,6 @@
       <GenerateDebugInformation>true</GenerateDebugInformation>
       <GenerateMapFile>true</GenerateMapFile>
       <MapFileName>$(TargetDir)$(TargetName).map</MapFileName>
-      <MapExports>false</MapExports>
       <SubSystem>Windows</SubSystem>
       <OptimizeReferences>true</OptimizeReferences>
       <EnableCOMDATFolding>true</EnableCOMDATFolding>
@@ -149,7 +147,6 @@
     <ClCompile>
       <Optimization>Disabled</Optimization>
       <IntrinsicFunctions>true</IntrinsicFunctions>
-      <FavorSizeOrSpeed>Speed</FavorSizeOrSpeed>
       <AdditionalIncludeDirectories>.;..\MemoryManager;..\scripts;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
       <PreprocessorDefinitions>D3D_DEBUG_INFO;DEBUG;MEMORY_MANAGER;RANDOMSTARTINGCREDITS_EXPORTS;WIN32;_CRT_SECURE_NO_DEPRECATE;_HAS_EXCEPTIONS=0;_WINDOWS;SSGMPLUGIN;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <StringPooling>true</StringPooling>
@@ -159,7 +156,7 @@
       <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
-      <EnableEnhancedInstructionSet>NoExtensions</EnableEnhancedInstructionSet>
+      <EnableEnhancedInstructionSet>StreamingSIMDExtensions2</EnableEnhancedInstructionSet>
       <FloatingPointModel>Precise</FloatingPointModel>
       <RuntimeTypeInfo>true</RuntimeTypeInfo>
       <PrecompiledHeader>Use</PrecompiledHeader>
diff -uwrN sourceold/scripts/DBIKScripts.cpp source/scripts/DBIKScripts.cpp
--- sourceold/scripts/DBIKScripts.cpp	2016-11-19 11:05:09.562453500 +1000
+++ source/scripts/DBIKScripts.cpp	2017-01-15 08:11:46.738802600 +1000
@@ -8,6 +8,7 @@
 #include "VehicleGameObj.h"
 #include "PurchaseSettingsDefClass.h"
 #include "GameObjManager.h"
+#include "DB_General.h"
 
 #define PI 3.14159265
 
@@ -29,7 +30,7 @@
 		{
 			PilotID = Commands->Get_ID(sender);
 			char params[50];
-			sprintf(params,"Deploy,%d,923572385",Commands->Get_ID(obj));
+			sprintf(params,"IKDeploy,%d,923572385",Commands->Get_ID(obj));
 			Commands->Attach_Script(sender,"Reborn_Deployable_Vehicle_Player",params);
 		}
 	}
@@ -167,8 +168,25 @@
 {
 	if(number==87)
 	{
+		if(obj->As_SoldierGameObj()->Is_On_Ladder())
+		{
+			if(OnLadder)
+			{
+				Commands->Set_Animation(obj,"s_a_human.H_A_a0a0_L23",false,0,0.0f,0.0f,false);
+				OnLadder=false;
+			}
+			else
+			{
+				OnLadder=true;
+			}
+		}
+		else
+		{
+			OnLadder=false;
+		}
 		if(obj->As_SoldierGameObj()->Get_State()==SoldierAIState::AI_STATE_IDLE && Commands->Get_Distance(Commands->Get_Position(obj),HomePosition)>5)
 		{
+			
 			ActionParamsStruct HomeAction;
 			HomeAction.Set_Basic(this,70,1);
 			HomeAction.Set_Movement(HomePosition,0.25,2,false);
@@ -367,7 +385,7 @@
 	MaxRange = Get_Float_Parameter("MaxRange");
 	ChargeTime = Get_Float_Parameter("ChargeTime");
 	GroundOnly = Get_Int_Parameter("GroundOnly");
-	/*dblaney_Nod_Obelisk_Weapon
+	/*
 	GameObject* WeaponObj = Commands->Create_Object(Preset, WeaponPos);
 	if (WeaponObj) {
 		WeaponID = Commands->Get_ID(WeaponObj);
@@ -1057,3 +1075,201 @@
 }
 
 ScriptRegistrant<DB_Infantry_Place_Buildable_Object> DB_Infantry_Place_Buildable_Object_Registrant("DB_Infantry_Place_Buildable_Object","WeaponPreset=null:string,DeployPreset=null:string,RepairedPreset=null:string,PlaceablePreview=null:string,UnPlaceablePreview=null:string,EnableCustom:int,DisableCustom:int,DeployCustom:int,RegainTimer:int,Cost:float,DeploymentBlockedMessage=Cannot deploy when near buildings.:string,PlacementMessage=You can now place another.:string,GrantWeapon=1:int,RegenStartsAfterRepair=1:int,MatchTeam=0:int,DestroyedRegenTime=1:int");
\ No newline at end of file
+
+void DB_Stationary_Stealth::Created(GameObject *obj)
+{
+	xpos = 0;
+	ypos = 0;
+	zpos = 0;
+	isHidden=false;
+	Commands->Start_Timer(obj,this,1.0f,572384);
+}
+
+void DB_Stationary_Stealth::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&xpos,4,2);
+	Auto_Save_Variable(&ypos,4,3);
+	Auto_Save_Variable(&zpos,4,4);
+}
+
+void DB_Stationary_Stealth::Timer_Expired(GameObject *obj,int number)
+{
+	if(number == 572384)
+	{
+		Vector3 position = Commands->Get_Position(obj);
+		if ((!xpos) && (!ypos) && (!zpos))
+		{
+			xpos = position.X;
+			ypos = position.Y;
+			zpos = position.Z;
+		}
+		if ((fabs(position.X-xpos) <= .5) && (fabs(position.Y-ypos) <= .5) && (fabs(position.Z-zpos) <= .5))
+		{
+			if(!isHidden && !Is_Script_Attached(obj,"Stealth_Powerup"))
+			{
+				isHidden=true;
+				Attach_Script_Once(obj,"Stealth_Stationary","");
+				Commands->Enable_Stealth(obj,true);
+			}
+		}
+		else if(isHidden)
+		{
+			/*
+			if(!Is_Script_Attached(obj,"Stealth_Powerup"))
+			{
+				Commands->Enable_Stealth(obj,false);
+			}
+			*/
+			Remove_Script(obj,"Stealth_Stationary");
+			isHidden=false;
+		}
+		xpos = position.X;
+		ypos = position.Y;
+		zpos = position.Z;
+		Commands->Start_Timer(obj,this,1.0f,572384);
+	}
+}
+
+ScriptRegistrant<DB_Stationary_Stealth> DB_Stationary_Stealth_Registrant("DB_Stationary_Stealth","");
+
+
+void DB_Turret_Sound::Created ( GameObject* obj )
+{
+  if ( VehicleGameObj* vObj = obj->As_VehicleGameObj() )
+  {
+    minRotate = Get_Float_Parameter("Min_Rotate_Amount");
+    lastFacing = Get_Turret_Facing(vObj->Peek_Model());
+    emitterID = -1;
+    Commands->Start_Timer(obj, this, 0.1f, 1 );
+  }
+  else
+  {
+    Destroy_Script();
+  }
+}
+
+void DB_Turret_Sound::Timer_Expired ( GameObject* obj, int number )
+{
+  if ( number == 1 )
+  {
+    if ( VehicleGameObj* vObj = obj->As_VehicleGameObj() )
+    {
+      float newFacing = Get_Turret_Facing(vObj->Peek_Model());
+
+      // Check if we are rotating - ignore tiny rotation amounts
+      bool rotating = ( abs(newFacing-lastFacing) > minRotate );
+
+      if ( emitterID == -1 && rotating)
+        Play_Sound(obj);
+
+      else if ( emitterID != -1 && !rotating )
+        Stop_Sound(obj);
+
+      lastFacing = newFacing;
+    }
+
+    // Restart timer to check for rotation
+    Commands->Start_Timer(obj, this, 0.1f, 1 );
+  }
+}
+
+float DB_Turret_Sound::Get_Turret_Facing ( RenderObjClass* RenderObj )
+{
+  if ( RenderObj )
+  {
+    Matrix3D vehicleTransform = RenderObj->Get_Transform();
+    Matrix3D transform = RenderObj->Get_Bone_Transform("turret");
+    return abs(vehicleTransform.Get_Z_Rotation()-transform.Get_Z_Rotation());
+  }
+
+  return 0.0f;
+}
+
+void DB_Turret_Sound::Play_Sound ( GameObject* obj )
+{
+	GameObject *soundemitter = Commands->Create_Object_At_Bone(obj, "Invisible_Object", "turret");
+	if(soundemitter)
+	{
+		Commands->Attach_To_Object_Bone(soundemitter,obj,"turret");
+		Commands->Set_Model(soundemitter,Get_Parameter("Sound_Emitter"));
+		emitterID=soundemitter->Get_ID();
+	}
+}
+
+void DB_Turret_Sound::Stop_Sound ( GameObject* obj )
+{
+	GameObject *soundemitter = Commands->Find_Object(emitterID);
+	if(soundemitter)
+	{
+		Commands->Destroy_Object(soundemitter);
+		emitterID = -1;
+	}
+}
+
+ScriptRegistrant<DB_Turret_Sound> DB_Turret_Sound_Registrant("DB_Turret_Sound","Sound_Emitter:string,Min_Rotate_Amount=0.05:float");
+
+void DB_Turret_Spawn::Created(GameObject *obj)
+{
+	GameObject *turret = Commands->Create_Object(Get_Parameter("Turret_Preset"),Vector3());
+	if(!turret)
+	{
+		Destroy_Script();
+		return;
+	}
+	Commands->Attach_To_Object_Bone(turret,obj,Get_Parameter("Bone_Name"));
+	turretId = Commands->Get_ID(turret);
+	if (turret->As_VehicleGameObj())
+		turret->As_VehicleGameObj()->Set_Is_Scripts_Visible(false);
+	hasDriver = false;
+}
+void DB_Turret_Spawn::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
+	{
+		if (!hasDriver)
+		{
+			hasDriver = true;
+			GameObject *turret = Commands->Find_Object(turretId);
+			if (turret)
+			{
+				Commands->Set_Player_Type(turret,Commands->Get_Player_Type(sender));
+				Commands->Action_Reset(turret,100);
+			}
+		}
+	}
+	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
+	{
+		if (hasDriver && obj->As_VehicleGameObj() && !Get_Vehicle_Occupant_Count(obj))
+		{
+			hasDriver = false;
+			GameObject *turret = Commands->Find_Object(turretId);
+			if (turret)
+			{
+				Commands->Set_Player_Type(turret,Commands->Get_Player_Type(obj));
+				Commands->Action_Reset(turret,100);
+			}
+		}
+	}
+	if (message == REATTACH_BONES_CUSTOM)
+	{
+		GameObject *turret = Commands->Find_Object(turretId);
+		if (turret)
+		{
+			Commands->Attach_To_Object_Bone(turret,obj,Get_Parameter("Bone_Name"));
+		}
+	}
+}
+void DB_Turret_Spawn::Killed(GameObject *obj,GameObject *killer)
+{
+	GameObject *turret = Commands->Find_Object(turretId);
+	if (turret)
+		Commands->Destroy_Object(turret);
+}
+void DB_Turret_Spawn::Destroyed(GameObject *obj)
+{
+	GameObject *turret = Commands->Find_Object(turretId);
+	if (turret)
+		Commands->Destroy_Object(turret);
+}
+
+ScriptRegistrant<DB_Turret_Spawn> DB_Turret_Spawn_Registrant("DB_Turret_Spawn","Turret_Preset:string,Bone_Name=Tur_Mount:string");
\ No newline at end of file
diff -uwrN sourceold/scripts/DBIKScripts.h source/scripts/DBIKScripts.h
--- sourceold/scripts/DBIKScripts.h	2016-11-19 11:05:09.562453500 +1000
+++ source/scripts/DBIKScripts.h	2017-01-15 08:11:46.740802600 +1000
@@ -22,6 +22,7 @@
 
 class DB_Guard_Bot : public ScriptImpClass {
 	Vector3 HomePosition;
+	bool OnLadder;
 	void Created(GameObject *obj);
 	void Damaged(GameObject *obj,GameObject *damager,float amount);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
@@ -145,3 +146,38 @@
 		placementBlocked = 0;
 	}
 };
\ No newline at end of file
+
+class DB_Stationary_Stealth : public ScriptImpClass {
+	float xpos;
+	float ypos;
+	float zpos;
+	bool isHidden;
+	void Created(GameObject *obj);
+	public: void Register_Auto_Save_Variables();
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+class DB_Turret_Sound : public ScriptImpClass
+{
+protected:
+  void Created ( GameObject* obj );
+  void Timer_Expired ( GameObject* obj, int number );
+  float Get_Turret_Facing ( class RenderObjClass* obj );
+  void Play_Sound ( GameObject* obj );
+  void Stop_Sound ( GameObject* obj );
+
+  float lastFacing;
+  int emitterID;
+
+  float minRotate;
+};
+
+class DB_Turret_Spawn : public ScriptImpClass
+{
+  int turretId;
+  bool hasDriver;
+  void Created(GameObject *obj);
+  void Custom(GameObject *obj,int message,int param,GameObject *sender);
+  void Killed(GameObject *obj,GameObject *killer);
+  void Destroyed(GameObject *obj);
+};
\ No newline at end of file
diff -uwrN sourceold/scripts/DBScripts.cpp source/scripts/DBScripts.cpp
--- sourceold/scripts/DBScripts.cpp	2016-11-25 15:02:11.915641100 +1000
+++ source/scripts/DBScripts.cpp	2017-01-22 19:56:58.286626000 +1000
@@ -5,7 +5,6 @@
 #include "BeaconGameObjDef.h"
 #include "gmplugin.h"
 #include "gmgame.h"
-#include "gmlog.h"
 #include "TeamPurchaseSettingsDefClass.h"
 #include "PurchaseSettingsDefClass.h"
 #include "PowerupGameObj.h"
@@ -728,8 +727,8 @@
 				{
 					weapon->Set_Clip_Rounds(weapon->Get_Definition()->ClipSize);
 				}
-				Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("BuildingID")),826455,Get_Object_Type(Aircraft),0);
 				*/
+				Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("BuildingID")),826455,Get_Object_Type(Aircraft),0);
 			}
 
 		Commands->Start_Timer(obj, this, 2, number);
diff -uwrN sourceold/scripts/DB_General.h source/scripts/DB_General.h
--- sourceold/scripts/DB_General.h	2016-11-19 11:50:02.490453700 +1000
+++ source/scripts/DB_General.h	2016-12-31 09:28:56.289000000 +1000
@@ -22,3 +22,5 @@
 	UPGRADE_INFANTRY_ARMOR_AMOUNT = 10,
 	UPGRADE_INFANTRY_ARMOR_CUSTOM = 70008001,
 };
+
+#define REATTACH_BONES_CUSTOM 9320943
\ No newline at end of file
diff -uwrN sourceold/scripts/DB_Research_Terminals.cpp source/scripts/DB_Research_Terminals.cpp
--- sourceold/scripts/DB_Research_Terminals.cpp	2016-11-25 15:02:11.925641100 +1000
+++ source/scripts/DB_Research_Terminals.cpp	2017-01-22 19:56:58.293626000 +1000
@@ -23,7 +23,15 @@
 #include "SoldierGameObjDef.h"
 #include "PowerupGameObjDef.h"
 #include "BuildingGameObj.h"
-#include "gmlog.h"
+
+void Set_Model_Custom(GameObject *obj,const char *Model_Name)
+{
+	if(obj)
+	{
+		Commands->Set_Model(obj,Model_Name);
+		Commands->Send_Custom_Event(obj,obj,REATTACH_BONES_CUSTOM,0,0);
+	}
+}
 
 void DB_Research_Listener::Created(GameObject *obj)
 {
@@ -524,7 +532,7 @@
 		Set_Max_Shield_Strength(obj, NewMaxAP);
 		Commands->Set_Shield_Strength(obj, NewAP);
 		if(strcmp(model,"") != 0)
-			Commands->Set_Model(obj,model);
+			Set_Model_Custom(obj,model);
 	}
 }
 void DB_Research_Infantry_Hitpoints_Ability::Custom(GameObject *obj, int message, int param, GameObject *sender)
@@ -546,7 +554,7 @@
 		Set_Max_Shield_Strength(obj, NewMaxAP);
 		Commands->Set_Shield_Strength(obj, NewAP);
 		if(strcmp(model,"") != 0)
-			Commands->Set_Model(obj,model);
+			Set_Model_Custom(obj,model);
 		Create_2D_Wave_Sound_Dialog_Player(obj, Get_Parameter("Unit_Upgraded_Sound"));
 		Send_Message_Player(obj,255,255,255,"Unit Upgraded!");
 	}
@@ -603,7 +611,7 @@
 			}
 			//Remove_Weapon(obj,Get_Weapon(obj,0));
 			if(strcmp(model,"") != 0)
-				Commands->Set_Model(obj,model);
+				Set_Model_Custom(obj,model);
 		}
 		else
 		{
@@ -665,7 +673,7 @@
 		}
 		
 		if(strcmp(model,"") != 0)
-			Commands->Set_Model(obj,model);
+			Set_Model_Custom(obj,model);
 		Create_2D_Wave_Sound_Dialog_Player(obj, Get_Parameter("Unit_Upgraded_Sound"));
 		Send_Message_Player(obj,255,255,255,"Unit Upgraded!");
 	}
@@ -700,7 +708,7 @@
 		Commands->Set_Health(obj, NewHP);
 
 		if(strcmp(model,"") != 0)
-			Commands->Set_Model(obj,model);
+			Set_Model_Custom(obj,model);
 	
 	}
 }
@@ -729,7 +737,7 @@
 
 
 		if(strcmp(model,"") != 0)
-			Commands->Set_Model(obj,model);
+			Set_Model_Custom(obj,model);
 		Create_2D_Wave_Sound_Dialog_Player(obj, Get_Parameter("Unit_Upgraded_Sound"));
 		Send_Message_Player(obj,255,255,255,"Unit Upgraded!");
 	}
@@ -749,7 +757,7 @@
 		const char *model = Get_Parameter("Model");
 		Attach_Script_V(obj,"dp88_buildingScripts_functionMoneyTrickle","%f",TickRate);
 		if(strcmp(model,"") != 0)
-			Commands->Set_Model(obj,model);
+			Set_Model_Custom(obj,model);
 	}
 }
 void DB_Research_Credit_Tick::Custom(GameObject *obj, int message, int param, GameObject *sender)
@@ -761,7 +769,7 @@
 		const char *model = Get_Parameter("Model");
 		Attach_Script_V(obj,"dp88_buildingScripts_functionMoneyTrickle","%f",TickRate);
 		if(strcmp(model,"") != 0)
-			Commands->Set_Model(obj,model);
+			Set_Model_Custom(obj,model);
 		Create_2D_Wave_Sound_Dialog_Player(obj, Get_Parameter("Unit_Upgraded_Sound"));
 		Send_Message_Player(obj,255,255,255,"Unit Upgraded!");
 
@@ -817,7 +825,7 @@
 	if(UpgradeComplete.Get(UpgradeID,0))
 	{
 		model = Get_Parameter("Upgraded_Model_Name");
-		Commands->Set_Model(obj,model);
+		Set_Model_Custom(obj,model);
 		float MaxHP = Commands->Get_Max_Health(obj);
 		float NewMaxHP = MaxHP + Get_Float_Parameter("Extra_Health_Amount");
 		float CurHP = Commands->Get_Health(obj);
@@ -841,7 +849,7 @@
 		model = Get_Parameter("Upgraded_Model_Name");
 		if(mode == 0)
 		{
-			Commands->Set_Model(obj,model);
+			Set_Model_Custom(obj,model);
 		}
 		else if(mode == 1)
 		{
@@ -849,7 +857,7 @@
 			sprintf(deployedmodel,"%s_d",model);
 			float frame = Get_Animation_Frame(obj);
 			char deployanim[512];
-			Commands->Set_Model(obj,deployedmodel);
+			Set_Model_Custom(obj,deployedmodel);
 			sprintf(deployanim,"%s_d.%s_d",model,model);
 			Commands->Set_Animation(obj,deployanim,false,0,frame,-1,0);
 		}
@@ -857,7 +865,7 @@
 		{
 			char deployedmodel[512];
 			sprintf(deployedmodel,"%s_dd",model);
-			Commands->Set_Model(obj,deployedmodel);
+			Set_Model_Custom(obj,deployedmodel);
 		}
 		else if(mode == 3)
 		{
@@ -865,7 +873,7 @@
 			sprintf(deployedmodel,"%s_d",model);
 			float frame = Get_Animation_Frame(obj);
 			char deployanim[512];
-			Commands->Set_Model(obj,deployedmodel);
+			Set_Model_Custom(obj,deployedmodel);
 			sprintf(deployanim,"%s_d.%s_d",model,model);
 			Commands->Set_Animation(obj,deployanim,false,0,frame,0,0);
 		}
@@ -919,7 +927,7 @@
 			{
 				obj->As_VehicleGameObj()->Set_Immovable(true);
 				mode = 1;
-				Commands->Set_Model(obj,dmodel);
+				Set_Model_Custom(obj,dmodel);
 				Commands->Set_Shield_Type(obj,Get_Parameter("Armor"));
 				Commands->Set_Animation(obj,deployanim,false,0,0,-1,0);
 				Commands->Clear_Weapons(obj);
@@ -935,7 +943,7 @@
 		else if (mode == 2)
 		{
 			mode = 3;
-			Commands->Set_Model(obj,dmodel);
+			Set_Model_Custom(obj,dmodel);
 			Commands->Set_Animation(obj,deployanim,false,0,Get_Float_Parameter("Last_Deploy_Frame"),0,0);
 			Commands->Clear_Weapons(obj);
 			Commands->Give_PowerUp(obj,Get_Parameter("Weapon_Powerup_Name2"),false);
@@ -959,7 +967,7 @@
 	if (!_stricmp(animation_name,deployanim) && (mode == 1))
 	{
 		mode = 2;
-		Commands->Set_Model(obj,deployedmodel);
+		Set_Model_Custom(obj,deployedmodel);
 		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Control_Enable(Commands->Find_Object(PilotID),true);
 		obj->As_VehicleGameObj()->Set_Scripts_Can_Fire(true);
@@ -974,7 +982,7 @@
 	{
 		obj->As_VehicleGameObj()->Set_Immovable(false);
 		mode = 0;
-		Commands->Set_Model(obj,model);
+		Set_Model_Custom(obj,model);
 		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Shield_Type(obj,Get_Parameter("Armor2"));
 		Commands->Control_Enable(Commands->Find_Object(PilotID),true);
diff -uwrN sourceold/scripts/RawFileClass.h source/scripts/RawFileClass.h
--- sourceold/scripts/RawFileClass.h	2016-10-31 07:17:12.391013500 +1000
+++ source/scripts/RawFileClass.h	2017-01-22 20:28:02.575035500 +1000
@@ -412,10 +412,10 @@
 			{
 				for (int i = 0;i < sz;i++)
 				{
-					if (buf[i] == 0xA)
+					if (buf[i] == '\n')
 					{
 						buf[i + 1] = 0;
-						Seek(1 - sz - i,1);
+						Seek(i - sz + 1,1);
 						b = false;
 					}
 				}
diff -uwrN sourceold/scripts/SoldierGameObj.h source/scripts/SoldierGameObj.h
--- sourceold/scripts/SoldierGameObj.h	2016-12-09 10:52:52.622021900 +1000
+++ source/scripts/SoldierGameObj.h	2017-01-05 11:59:07.160605800 +1000
@@ -272,6 +272,8 @@
 	bool						movementLoitersAllowed;
 	bool						useStockGhostBehavior;
 	bool						OverrideMuzzleDirection;
+	bool						UpdatedTarget;
+	bool						DoTilt;
 	TT_DEPRECATED("Do not use") int						Check(void);
 }; // size: 3404
 
